<template>
  <div>
    <LinkTitlesCustom
      :currentPaths="['考试管理', '考试信息', '网络考试设置']"
    />
    <section class="content">
      <div class="box box-info">
        <!-- 正文信息 -->
        <div class="box-body">
          <el-form
            :inline="true"
            :rules="rules"
            ref="form"
            :model="form"
            inline-message
            label-position="right"
          >
            <div style="margin-bottom: 10px;">
              <el-button type="primary" size="small" @click="saveExam"
                >保 存</el-button
              >
              <el-button
                type="primary"
                size="small"
                @click="back"
                icon="el-icon-arrow-left"
                >返 回</el-button
              >
            </div>
            <el-tabs type="border-card" v-model="activeName">
              <!-- 基础信息 -->
              <el-tab-pane label="基础信息" name="tab1">
                <el-row v-if="examId != 'add'">
                  <el-form-item
                    label="ID"
                    prop="id"
                    :label-width="style.label_width_tab1"
                  >
                    <el-input
                      v-model="form.id"
                      class="input"
                      :disabled="true"
                      maxlength="20"
                    ></el-input>
                  </el-form-item>
                </el-row>
                <el-row v-if="examId != 'add'">
                  <el-form-item
                    label="考试编码"
                    placeholder="请输入考试编码"
                    prop="code"
                    :label-width="style.label_width_tab1"
                  >
                    <el-input
                      v-model="form.code"
                      class="input"
                      :disabled="true"
                      maxlength="20"
                    ></el-input>
                  </el-form-item>
                </el-row>
                <el-row v-else>
                  <el-form-item
                    label="考试编码"
                    placeholder="请输入考试编码"
                    prop="code"
                    :label-width="style.label_width_tab1"
                  >
                    <el-input
                      v-model="form.name"
                      class="input"
                      :disabled="true"
                      maxlength="20"
                    ></el-input>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="考试名称"
                    placeholder="请输入考试名称"
                    prop="name"
                    :label-width="style.label_width_tab1"
                  >
                    <el-input
                      v-model="form.name"
                      class="input"
                      maxlength="20"
                    ></el-input>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="考试类型"
                    :label-width="style.label_width_tab1"
                  >
                    <el-select
                      class="input"
                      :disabled="true"
                      v-model="form.examType"
                      placeholder="请选择"
                    >
                      <el-option
                        v-for="item in examTypeList"
                        :key="item.value"
                        :label="item.label"
                        :value="item.value"
                      ></el-option>
                    </el-select>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="状态"
                    :label-width="style.label_width_tab1"
                  >
                    <el-radio-group v-model="form.enable" class="input">
                      <el-radio label="true">启用</el-radio>
                      <el-radio label="false">禁用</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
                <el-row v-if="1 == 2">
                  <el-form-item
                    label="是否可以考试"
                    :label-width="style.label_width_tab1"
                  >
                    <el-radio-group v-model="form.examLimit" class="input">
                      <el-radio label="true">否</el-radio>
                      <el-radio label="false">是</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="考试时间"
                    prop="examDatetimeRange"
                    :label-width="style.label_width_tab1"
                  >
                    <el-date-picker
                      class="input"
                      v-model="examDatetimeRange"
                      type="datetimerange"
                      range-separator="至"
                      start-placeholder="开始日期"
                      end-placeholder="结束日期"
                      value-format="yyyy-MM-dd HH:mm:ss"
                      :clearable="false"
                    ></el-date-picker>
                  </el-form-item>
                </el-row>
              </el-tab-pane>
              <!-- 控制设置 -->
              <el-tab-pane label="控制设置" name="tab2">
                <el-row>
                  <el-form-item
                    label="考试时长"
                    prop="duration"
                    :label-width="style.label_width_tab2"
                  >
                    <el-input
                      maxlength="5"
                      v-model.trim.number="form.duration"
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >分钟</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="考试次数"
                    prop="examTimes"
                    :label-width="style.label_width_tab2"
                  >
                    <el-input
                      maxlength="5"
                      v-model.trim.number="form.examTimes"
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >次</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="交卷冻结时间"
                    prop="FREEZE_TIME"
                    :label-width="style.label_width_tab2"
                  >
                    <el-input
                      maxlength="5"
                      v-model.trim.number="form.properties.FREEZE_TIME"
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >分钟</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="断点续考时间"
                    prop="EXAM_RECONNECT_TIME"
                    :label-width="style.label_width_tab2"
                  >
                    <el-input
                      maxlength="5"
                      v-model.trim.number="form.properties.EXAM_RECONNECT_TIME"
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >分钟</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="断点续考次数"
                    prop="MAX_INTERRUPT_NUM"
                    :label-width="style.label_width_tab2"
                  >
                    <el-input
                      maxlength="5"
                      v-model.trim.number="form.properties.MAX_INTERRUPT_NUM"
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >次</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
              </el-tab-pane>
              <el-tab-pane label="显示设置" name="tab3">
                <el-row v-if="show_ckeditor">
                  <el-form-item
                    label="考前说明"
                    :label-width="style.label_width_tab3"
                  >
                    <ckeditor
                      v-model="form.properties.BEFORE_EXAM_REMARK"
                    ></ckeditor>
                  </el-form-item>
                </el-row>
                <el-row v-if="show_ckeditor">
                  <el-form-item
                    label="考后说明"
                    :label-width="style.label_width_tab3"
                  >
                    <ckeditor
                      v-model="form.properties.AFTER_EXAM_REMARK"
                    ></ckeditor>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="展示作弊说明"
                    :label-width="style.label_width_tab3"
                  >
                    <el-radio-group
                      v-model="form.properties.SHOW_CHEATING_REMARK"
                      class="input"
                    >
                      <el-radio label="true">开启</el-radio>
                      <el-radio label="false">关闭</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
                <el-row v-if="show_ckeditor">
                  <el-form-item
                    label="作弊说明"
                    :label-width="style.label_width_tab3"
                  >
                    <ckeditor
                      v-model="form.properties.CHEATING_REMARK"
                    ></ckeditor>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="单选题补充说明"
                    :label-width="style.label_width_tab3"
                  >
                    <el-input
                      maxlength="20"
                      :disabled="!form.properties.SINGLE_EDIT"
                      v-model="form.properties.SINGLE_ANSWER_REMARK"
                      auto-complete="off"
                      class="input"
                    ></el-input>
                  </el-form-item>
                  <el-form-item label>
                    <el-switch
                      v-model="form.properties.SINGLE_EDIT"
                      on-text="启用"
                      off-text="禁用"
                    ></el-switch>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="多选题补充说明"
                    :label-width="style.label_width_tab3"
                  >
                    <el-input
                      maxlength="20"
                      :disabled="!form.properties.MUTIPLE_EDIT"
                      v-model="form.properties.MUTIPLE_ANSWER_REMARK"
                      auto-complete="off"
                      class="input"
                    ></el-input>
                  </el-form-item>
                  <el-form-item label>
                    <el-switch
                      v-model="form.properties.MUTIPLE_EDIT"
                      on-text="启用"
                      off-text="禁用"
                    ></el-switch>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="判断题补充说明"
                    :label-width="style.label_width_tab3"
                  >
                    <el-input
                      maxlength="20"
                      :disabled="!form.properties.BOOL_EDIT"
                      v-model="form.properties.BOOL_ANSWER_REMARK"
                      class="input"
                      auto-complete="off"
                    ></el-input>
                  </el-form-item>
                  <el-form-item label>
                    <el-switch
                      v-model="form.properties.BOOL_EDIT"
                      on-text="启用"
                      off-text="禁用"
                    ></el-switch>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="填空题补充说明"
                    :label-width="style.label_width_tab3"
                  >
                    <el-input
                      maxlength="20"
                      :disabled="!form.properties.FILL_BLANK_EDIT"
                      v-model="form.properties.FILL_BLANK_REMARK"
                      class="input"
                      auto-complete="off"
                    ></el-input>
                  </el-form-item>
                  <el-form-item label>
                    <el-switch
                      v-model="form.properties.FILL_BLANK_EDIT"
                      on-text="启用"
                      off-text="禁用"
                    ></el-switch>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="客观题成绩显示"
                    :label-width="style.label_width_tab3"
                  >
                    <el-radio-group
                      v-model="form.properties.IS_OBJ_SCORE_VIEW"
                      class="input"
                    >
                      <el-radio label="true">开启</el-radio>
                      <el-radio label="false">关闭</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
              </el-tab-pane>
              <el-tab-pane label="身份检测设置" name="tab4">
                <el-row>
                  <el-form-item
                    label="开启身份检测"
                    :label-width="style.label_width_tab4"
                  >
                    <el-radio-group
                      v-model="form.properties.IS_FACE_ENABLE"
                      :disabled="this.is_face_enable_diabled"
                      class="input"
                    >
                      <el-radio label="true">是</el-radio>
                      <el-radio label="false">否</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="启用陌生人检测"
                    prop="IS_STRANGER_ENABLE"
                    :label-width="style.label_width_tab4"
                    v-show="form.properties.IS_FACE_ENABLE == 'true'"
                  >
                    <el-radio-group
                      v-model="form.properties.IS_STRANGER_ENABLE"
                      class="input"
                    >
                      <el-radio label="true">是</el-radio>
                      <el-radio label="false">否</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
                <el-row v-show="form.properties.IS_FACE_ENABLE == 'true'">
                  <el-form-item
                    label="考试强制使用"
                    :label-width="style.label_width_tab4"
                  >
                    <el-radio-group
                      v-model="form.properties.IS_FACE_CHECK"
                      class="input"
                    >
                      <el-radio label="true">强制</el-radio>
                      <el-radio label="false">非强制</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
                <el-row v-show="form.properties.IS_FACE_ENABLE == 'true'">
                  <el-form-item
                    label="抓拍间隔"
                    prop="SNAPSHOT_INTERVAL"
                    :label-width="style.label_width_tab4"
                  >
                    <el-input
                      maxlength="5"
                      v-model.trim.number="form.properties.SNAPSHOT_INTERVAL"
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >分钟</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
                <el-row v-show="form.properties.IS_FACE_ENABLE == 'true'">
                  <el-form-item
                    label="预警阀值"
                    prop="WARN_THRESHOLD"
                    :label-width="style.label_width_tab4"
                  >
                    <el-input
                      maxlength="5"
                      v-model.trim.number="form.properties.WARN_THRESHOLD"
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >%</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
                <el-row v-show="form.properties.IS_FACE_ENABLE == 'true'">
                  <el-form-item
                    label="真实性预警阀值"
                    prop="LIVING_WARN_THRESHOLD"
                    :label-width="style.label_width_tab4"
                  >
                    <el-input
                      maxlength="5"
                      v-model.number="form.properties.LIVING_WARN_THRESHOLD"
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >%</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
                <el-row v-show="form.properties.IS_FACE_ENABLE == 'true'">
                  <el-form-item
                    label="开启人脸活体检测"
                    :label-width="style.label_width_tab4"
                  >
                    <el-radio-group
                      v-model="form.properties.IS_FACE_VERIFY"
                      :disabled="this.is_face_verify_diabled"
                      class="input"
                    >
                      <el-radio label="true">是</el-radio>
                      <el-radio label="false">否</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
                <el-row v-show="form.properties.IS_FACE_VERIFY == 'true'">
                  <el-form-item
                    label="人脸活体检测开始时间"
                    prop="FACE_VERIFY_START_MINUTE"
                    :label-width="style.label_width_tab4"
                  >
                    <el-input
                      maxlength="5"
                      v-model.trim.number="
                        form.properties.FACE_VERIFY_START_MINUTE
                      "
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >分钟</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
                <el-row v-show="form.properties.IS_FACE_VERIFY == 'true'">
                  <el-form-item
                    label="人脸活体检测结束时间"
                    prop="FACE_VERIFY_END_MINUTE"
                    :label-width="style.label_width_tab4"
                  >
                    <el-input
                      maxlength="5"
                      v-model.trim.number="
                        form.properties.FACE_VERIFY_END_MINUTE
                      "
                      auto-complete="off"
                      class="input"
                    >
                      <template slot="append"
                        >分钟</template
                      >
                    </el-input>
                  </el-form-item>
                </el-row>
              </el-tab-pane>
              <el-tab-pane label="阅卷设置" name="tab5">
                <el-row>
                  <el-form-item
                    label="阅卷方式"
                    :label-width="style.label_width_tab5"
                  >
                    <el-radio-group
                      :disabled="form.started"
                      v-model="form.properties.MARKING_TYPE"
                      class="input"
                    >
                      <el-radio label="ALL">全部评阅</el-radio>
                      <el-radio label="OBJECT_SCORE_MAX">客观分最高</el-radio>
                      <el-radio label="LAST_SUBMIT">最后一次提交</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
              </el-tab-pane>
              <el-tab-pane label="网络设置" name="tab6">
                <el-row>
                  <el-form-item
                    label="IP限制"
                    :label-width="style.label_width_tab6"
                  >
                    <el-radio-group v-model="form.properties.IP_LIMIT">
                      <el-radio label="true">开启</el-radio>
                      <el-radio label="false">关闭</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="IP段( *表示任意 )"
                    :label-width="style.label_width_tab6"
                  >
                    <el-input
                      maxlength="2000"
                      v-model="form.properties.IP_ADDRESSES"
                      class="input"
                      type="textarea"
                      rows="6"
                    ></el-input>
                  </el-form-item>
                </el-row>
              </el-tab-pane>
              <el-tab-pane label="其它" name="tab7">
                <el-row>
                  <el-form-item
                    label="是否推送成绩"
                    :label-width="style.label_width_tab7"
                  >
                    <el-radio-group v-model="form.properties.PUSH_SCORE">
                      <el-radio label="true">是</el-radio>
                      <el-radio label="false">否</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
                <el-row>
                  <el-form-item
                    label="是否开启环境检测"
                    :label-width="style.label_width_tab7"
                  >
                    <el-radio-group v-model="form.properties.CHECK_ENVIRONMENT">
                      <el-radio label="true">是</el-radio>
                      <el-radio label="false">否</el-radio>
                    </el-radio-group>
                  </el-form-item>
                </el-row>
              </el-tab-pane>
            </el-tabs>
          </el-form>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import { EXAM_TYPE, EXAM_WORK_API, CORE_API } from "@/constants/constants.js";
import moment from "moment";
import ckeditor from "@/components/ckeditor.vue";
import LinkTitlesCustom from "@/components/LinkTitlesCustom.vue";
let _this = null;

let validateCode = (rule, value, callback) => {
  if (_this.examId == "add") {
    _this.form.code = _this.form.name;
  }
  let code = _this.form.code;
  if (code == "") {
    callback(new Error("请输入考试编码"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab1";
      _this.activeName = "tab1";
    }
  } else {
    callback();
  }
};

let validateName = (rule, value, callback) => {
  let name = _this.form.name;
  if (name == "") {
    callback(new Error("请输入考试名称"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab1";
      _this.activeName = "tab1";
    }
  } else {
    callback();
  }
};

let validateExamDatetimeRange = (rule, value, callback) => {
  let examDatetimeRange = _this.examDatetimeRange;
  if (!examDatetimeRange) {
    callback(new Error("请输入考试时间"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab1";
      _this.activeName = "tab1";
    }
  } else {
    callback();
  }
};

let validateDuration = (rule, value, callback) => {
  let duration = _this.form.duration;
  if (duration === "") {
    callback(new Error("请输入考试时长"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else if (!duration.toString().match(/^[1-9]\d*|0$/)) {
    callback(new Error("只能是非负整数"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else {
    callback();
  }
};

let validateExamTimes = (rule, value, callback) => {
  let examTimes = _this.form.examTimes;
  if (examTimes === "") {
    callback(new Error("请输入考试次数"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else if (!examTimes.toString().match(/^[1-9]\d*$/)) {
    callback(new Error("只能是正整数"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else {
    callback();
  }
};

let validateFreezeTime = (rule, value, callback) => {
  let freezeTime = _this.form.properties.FREEZE_TIME;
  let duration = _this.form.duration;
  if (freezeTime === "") {
    callback(new Error("请输入交卷冻结时长"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else if (!freezeTime.toString().match(/^[1-9]\d*|0$/)) {
    callback(new Error("只能是非负整数"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else if (duration != "" && parseInt(freezeTime) > parseInt(duration)) {
    callback(new Error("交卷冻结时长不能大于考试时长"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else {
    callback();
  }
};

let validateExamReconnectTime = (rule, value, callback) => {
  let examReconnectTime = _this.form.properties.EXAM_RECONNECT_TIME;
  if (examReconnectTime === "") {
    callback(new Error("请输入断点续考时间"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else if (!examReconnectTime.toString().match(/^[1-9]\d*$/)) {
    callback(new Error("只能是正整数"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else {
    callback();
  }
};

let validateMaxInterruptNum = (rule, value, callback) => {
  let examReconnectTime = _this.form.properties.MAX_INTERRUPT_NUM;
  if (examReconnectTime === "") {
    callback();
  } else if (!examReconnectTime.toString().match(/^[0-9]\d*$/)) {
    callback(new Error("只能是非负整数"));
    if (!_this.toActiveName) {
      _this.toActiveName = "tab2";
      _this.activeName = "tab2";
    }
  } else {
    callback();
  }
};

let validateSnapshotInterval = (rule, value, callback) => {
  let isFaceEnable = _this.form.properties.IS_FACE_ENABLE;
  let snapshotnterval = _this.form.properties.SNAPSHOT_INTERVAL;
  let duration = _this.form.duration;
  if (isFaceEnable == "true") {
    if (snapshotnterval === "") {
      callback(new Error("请输入抓拍间隔"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else if (!snapshotnterval.toString().match(/^[1-9]\d*$/)) {
      callback(new Error("只能是正整数"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else if (
      duration != "" &&
      parseInt(snapshotnterval) > parseInt(duration)
    ) {
      callback(new Error("抓拍间隔不能大于考试时长"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else {
      callback();
    }
  } else {
    callback();
  }
};
let validateWarnThreshold = (rule, value, callback) => {
  let isFaceEnable = _this.form.properties.IS_FACE_ENABLE;
  let warnThreshold = _this.form.properties.WARN_THRESHOLD;
  if (isFaceEnable == "true") {
    if (warnThreshold === "") {
      callback(new Error("请输入预警阀值"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else if (!warnThreshold.toString().match(/^[1-9]\d*|0$/)) {
      callback(new Error("只能是非负整数"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else {
      callback();
    }
  } else {
    callback();
  }
};
let validateLivingWarnThreshold = (rule, value, callback) => {
  let isFaceEnable = _this.form.properties.IS_FACE_ENABLE;
  let livingWarnThreshold = _this.form.properties.LIVING_WARN_THRESHOLD;
  if (isFaceEnable == "true") {
    if (livingWarnThreshold === "") {
      callback(new Error("请输入真实性预警阀值"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else if (!livingWarnThreshold.toString().match(/^[1-9]\d*|0$/)) {
      callback(new Error("只能是非负整数"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else {
      callback();
    }
  } else {
    callback();
  }
};

let validateFaceVerifyStartMinute = (rule, value, callback) => {
  let isFaceVerify = _this.form.properties.IS_FACE_VERIFY;
  let freezeTime = _this.form.properties.FREEZE_TIME;
  let v = _this.form.properties.FACE_VERIFY_START_MINUTE;
  if (isFaceVerify == "true") {
    if (v === "") {
      callback(new Error("请输入活体检测开始分钟数"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else if (!v.toString().match(/^[1-9]\d*$/)) {
      callback(new Error("只能是正整数"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else if (freezeTime !== "" && parseInt(v) > parseInt(freezeTime)) {
      callback(new Error("活体检测开始分钟数不能大于交卷冻结时长"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else {
      callback();
    }
  } else {
    callback();
  }
};

let validateFaceVerifyEndMinute = (rule, value, callback) => {
  let isFaceVerify = _this.form.properties.IS_FACE_VERIFY;
  let freezeTime = _this.form.properties.FREEZE_TIME;
  let start = _this.form.properties.FACE_VERIFY_START_MINUTE;
  let v = _this.form.properties.FACE_VERIFY_END_MINUTE;
  if (isFaceVerify == "true") {
    if (v === "") {
      callback(new Error("请输入活体检测结束分钟数"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else if (!v.toString().match(/^[1-9]\d*$/)) {
      callback(new Error("只能是正整数"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else if (start !== "" && parseInt(v) < parseInt(start)) {
      callback(new Error("活体检测结束分钟数不能小于活体检测开始分钟数"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else if (freezeTime !== "" && parseInt(v) > parseInt(freezeTime)) {
      callback(new Error("活体检测结束分钟数不能大于交卷冻结时长"));
      if (!_this.toActiveName) {
        _this.toActiveName = "tab4";
        _this.activeName = "tab4";
      }
    } else {
      callback();
    }
  } else {
    callback();
  }
};

export default {
  components: {
    ckeditor,
    LinkTitlesCustom
  },
  data() {
    return {
      style: {
        label_width_tab1: "100px",
        label_width_tab2: "110px",
        label_width_tab3: "120px",
        label_width_tab4: "170px",
        label_width_tab5: "80px",
        label_width_tab6: "120px",
        label_width_tab7: "150px"
      },
      activeName: "tab1",
      toActiveName: null,
      examDatetimeRange: [],
      show_ckeditor: false,
      is_face_verify_diabled: true,
      is_face_enable_diabled: true,
      form: {
        started: false,
        name: "",
        code: "",
        examType: "ONLINE",
        examTimes: 1,
        beginTime: null,
        endTime: null,
        duration: 120,
        enable: "true",
        examLimit: "false",
        properties: {
          IS_OBJ_SCORE_VIEW: "true",
          IS_STRANGER_ENABLE: "false",
          MAX_INTERRUPT_NUM: "",
          EXAM_RECONNECT_TIME: 30,
          FREEZE_TIME: 0,
          BEFORE_EXAM_REMARK: "",
          AFTER_EXAM_REMARK: "",
          SHOW_CHEATING_REMARK: "true",
          CHEATING_REMARK: "",
          SINGLE_EDIT: "false",
          MUTIPLE_EDIT: "false",
          BOOL_EDIT: "false",
          FILL_BLANK_EDIT: "false",
          SINGLE_ANSWER_REMARK: "",
          MUTIPLE_ANSWER_REMARK: "",
          FILL_BLANK_REMARK: "",
          BOOL_ANSWER_REMARK: "",
          IS_FACE_ENABLE: "false",
          IS_FACE_CHECK: "false",
          SNAPSHOT_INTERVAL: 30,
          WARN_THRESHOLD: 50,
          MARKING_TYPE: "ALL",
          IP_LIMIT: "false",
          IP_ADDRESSES: null,
          LIVING_WARN_THRESHOLD: 50,
          IS_FACE_VERIFY: "false",
          FACE_VERIFY_START_MINUTE: 5,
          FACE_VERIFY_END_MINUTE: 10,
          PUSH_SCORE: "false",
          CHECK_ENVIRONMENT: "false"
        }
      },
      examTypeList: EXAM_TYPE,
      examId: "",
      rules: {
        code: [{ required: true, validator: validateCode, trigger: "blur" }],
        name: [{ required: true, validator: validateName, trigger: "blur" }],
        examDatetimeRange: [
          {
            required: true,
            validator: validateExamDatetimeRange,
            trigger: "blur"
          }
        ],
        duration: [
          { required: true, validator: validateDuration, trigger: "blur" }
        ],
        examTimes: [
          { required: true, validator: validateExamTimes, trigger: "blur" }
        ],
        FREEZE_TIME: [
          { required: true, validator: validateFreezeTime, trigger: "blur" }
        ],
        EXAM_RECONNECT_TIME: [
          {
            required: true,
            validator: validateExamReconnectTime,
            trigger: "blur"
          }
        ],
        MAX_INTERRUPT_NUM: [
          {
            required: false,
            validator: validateMaxInterruptNum,
            trigger: "blur"
          }
        ],
        SNAPSHOT_INTERVAL: [
          {
            required: true,
            validator: validateSnapshotInterval,
            trigger: "blur"
          }
        ],
        WARN_THRESHOLD: [
          { required: true, validator: validateWarnThreshold, trigger: "blur" }
        ],
        FACE_VERIFY_START_MINUTE: [
          {
            required: true,
            validator: validateFaceVerifyStartMinute,
            trigger: "blur"
          }
        ],
        FACE_VERIFY_END_MINUTE: [
          {
            required: true,
            validator: validateFaceVerifyEndMinute,
            trigger: "blur"
          }
        ],
        LIVING_WARN_THRESHOLD: [
          {
            required: true,
            validator: validateLivingWarnThreshold,
            trigger: "blur"
          }
        ]
      }
    };
  },

  methods: {
    init() {
      if (this.examId != "add") {
        let url = EXAM_WORK_API + "/exam/" + this.examId;
        this.$httpWithMsg.get(url).then(response => {
          let body = response.data;
          body.properties = this.form.properties;
          this.form = Object.assign(this.form, response.data);
          this.form.enable = this.form.enable ? "true" : "false";
          this.form.examLimit = this.form.examLimit ? "true" : "false";
          this.examDatetimeRange = [this.form.beginTime, this.form.endTime];
          console.log("getOnlineExam(); form: ", this.form);

          let url = EXAM_WORK_API + "/exam/allProperties/" + this.examId;
          this.$httpWithMsg.get(url).then(response => {
            this.form.properties = Object.assign(
              this.form.properties,
              response.data
            );

            this.form.properties.SINGLE_EDIT =
              this.form.properties.SINGLE_EDIT === "true";
            this.form.properties.MUTIPLE_EDIT =
              this.form.properties.MUTIPLE_EDIT === "true";
            this.form.properties.BOOL_EDIT =
              this.form.properties.BOOL_EDIT === "true";
            this.form.properties.FILL_BLANK_EDIT =
              this.form.properties.FILL_BLANK_EDIT === "true";

            this.show_ckeditor = true;

            this.checkRootOrgPrivileges();
          });
        });
      } else {
        let now = moment().format("YYYY-MM-DD HH:mm:ss");
        this.examDatetimeRange = [now, now];
        this.show_ckeditor = true;
        this.checkRootOrgPrivileges();
      }
    },
    checkRootOrgPrivileges: function() {
      let url =
        CORE_API +
        "/rolePrivilege/checkRootOrgPrivileges?privilegeCodes=FACE_CHECK,IDENTIFICATION_OF_LIVING_BODY";
      this.$httpWithMsg.post(url).then(response => {
        let res = response.data;
        if (!res.FACE_CHECK) {
          this.form.properties.IS_FACE_ENABLE = "false";
          this.is_face_enable_diabled = true;
        } else {
          this.is_face_enable_diabled = false;
        }
        if (!res.IDENTIFICATION_OF_LIVING_BODY) {
          this.is_face_verify_diabled = true;
          this.form.properties.IS_FACE_VERIFY = "false";
        } else {
          this.is_face_verify_diabled = false;
        }
      });
    },
    saveExam: function() {
      this.toActiveName = null;
      this.form.beginTime = this.examDatetimeRange[0];
      this.form.endTime = this.examDatetimeRange[1];
      console.log(this.form);
      let url = EXAM_WORK_API + "/exam";
      this.$refs.form.validate(valid => {
        if (valid) {
          if (this.examId != "add") {
            this.$httpWithMsg.put(url, this.form).then(response => {
              if (200 != response.status) {
                this.$notify({
                  type: "error",
                  message: response.body.desc
                });
                return;
              }
              this.$notify({
                type: "success",
                message: "保存成功"
              });
            });
          } else {
            this.form.code = this.form.name;
            this.$httpWithMsg.post(url, this.form).then(response => {
              console.log(response);
              this.$notify({
                type: "success",
                message: "新增成功"
              });
              this.examId = response.data.id;
              this.form.id = this.examId;
              this.$router.push({
                path: "/examwork/onlineExam/" + response.data.id
              });
            });
          }
        } else {
          return false;
        }
      });
    },
    back() {
      this.$router.push({ path: "/examwork/examInfo" });
    }
  },
  created() {
    _this = this;
    this.examId = this.$route.params.id;
    this.init();
  }
};
</script>
<style scoped>
.input {
  width: 440px;
}
.input >>> .el-input__inner {
  -webkit-appearance: button;
}
</style>
